Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA01.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA01.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA01.m	(revision 623)
@@ -1,75 +1,73 @@
-DGRUGA01	;ALB/GRR - HL7 ADT A01 MESSAGE BUILDER ; 11/27/07 1:43pm
-	;;5.3;Registration;**190,303,762**;Aug 13, 1993;Build 3
-	;
-	;This routine will build a ADT A01 (Admit) HL7 message for an inpatient.
-	;
-EN(DFN,DGMIEN,DGARRAY)	;Entry point of routine
-	;DFN - Patient Internal Entry Number
-	;DGMIEN - Patient Movement Internal Entry Number
-	;DGARRAY - Name of output array by reference where built message will be contained.
-	;
-	;The HL7 variables must be initialized before calling this routine!
-	;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
-	;
-	N DGPV1,DGHOLD,DGCNT,DGMDT,DGCDT,DGOADT,DGZEL,DGICD,DGICDCNT,DGIN,DGIN1,DGRB,DGW,DGINCNT S DGCNT=0
-	Q:DGARRAY=""  ;Required output variable name was not passed
-	K @DGARRAY ;Kill output array to insure erroneous data does not exist
-	Q:DGMIEN=""
-	S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
-	D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
-	S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
-	S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A01","05",DGMDT) ;Create Event segment and store in output array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
-	S DGHOLD=$$EN^VAFHLNK1(DFN,DGMIEN,",2,3,4,5,") ;Create the NK1 segment using the segment sequence numbers passed, and store in output array
-	I DGHOLD]"" S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGHOLD
-	S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
-	S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,",$G(DGMIEN),"","") ;Create the PV1 segment based on sequence numbers passed, and store in output array
-	S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;Check if integrated site and get original admit date
-	;Check if doing data seed of RAI/MDS machine
-	I $G(DGSEED)=1 D
-	.N VAIP,DGPCPNM,DGPCPPTR,DGWPTR,DGRBPTR,DGWTRAN,DGRBTRAN
-	.D IN5^VADPT
-	.;Put current Primary Care Physician into PV1 segment
-	.S DGPCPPTR=+$G(VAIP(7))
-	.S DGPCPNM=$$HLNAME^HLFNC($P($G(VAIP(7)),"^",2))
-	.S:DGPCPNM="" DGPCPNM=HL("Q")
-	.S $P(DGPV1,HL("FS"),8)=DGPCPPTR_$E(HL("ECH"))_DGPCPNM
-	.K ATTDOC S ATTDOC=$$ATTDOC^DGRUUTL(.ATTDOC) S $P(DGPV1,HL("FS"),18)=ATTDOC K ATTDOC ; P-762
-	.;Get current ward & room/bed
-	.S DGW=$$GET1^DIQ(2,DFN,.1,"I")
-	.S DGRB=$$GET1^DIQ(2,DFN,.101,"I")
-	.;Convert ward & room/bed to pointers
-	.S DGWPTR=$$FIND1^DIC(42,,"XQ",DGW)
-	.S DGRBPTR=$$FIND1^DIC(405.4,,"XQ",DGRB)
-	.;Translate ward & room/bed
-	.S DGWTRAN=$$WARDTRAN^DGRUUTL1(DGWPTR,DGW)
-	.S DGRBTRAN=$$RBTRAN^DGRUUTL1(DGRBPTR,DGRB)
-	.;Put translated ward & room/bed into PV1 segment
-	.S $P(DGPV1,HL("FS"),4)=DGWTRAN_$E(HL("ECH"))_$P(DGRBTRAN,"-")_$E(HL("ECH"))_$P(DGRBTRAN,"-",2)
-	I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT) S $P(@DGARRAY@(1),HL("FS"),7)=$$HLDATE^HLFNC(DGOADT)
-	S DGPV1=$$DOCID^DGRUUTL(DGPV1)
-	K ATTDOC S ATTDOC=$$ATTDOC^DGRUUTL(.ATTDOC) S $P(DGPV1,HL("FS"),18)=ATTDOC K ATTDOC ; P-762
-	;TRANSLATE WARD AND ROOM-BED NAMES IF NEEDED (ALREADY DONE IF SEEDING)
-	S:'$G(DGSEED) DGPV1=$$LOCTRAN^DGRUUTL1(DGPV1)
-	S @DGARRAY@(DGCNT)=DGPV1
-	S DGCNT=DGCNT+1 ;Increment node counter to store next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLPV2(DFN,DGMIEN,",3,") ;Create PV2 segment
-	D IN^VAFHLDG1(DFN,DGMIEN,",2,3,5,","DGICD",DGMDT) ;Create the DG1 segment(s) and store in a temporary array
-	I $O(DGICD(0))>0 D  ;DG1 segment were built
-	.S DGICDCNT=0 F  S DGICDCNT=$O(DGICD(DGICDCNT)) Q:DGICDCNT=""  S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGICD(DGICDCNT,0) ;Loop through temporary array and store DG1 segment(s) in output array
-	S DGIN1=$$IN1^DGRUUTL1(DFN)
-	S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGIN1
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLIN2(DFN,DGMIEN,",2,3,6,8,") ;Create and store IN2 segment in output array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S DGZEL=$$EN^VAFHLZEL(DFN,",1,8,",1) ;Create ZEL segment (only primary eligibility - param 3 = 1)
-	I $P(DGZEL,HL("FS"),9)'=0&($P(DGZEL,HL("FS"),9)'=1) S $P(DGZEL,HL("FS"),9)=1 ;stuff patient as veteran
-	S @DGARRAY@(DGCNT)=DGZEL
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZEM(DFN,",1,5,",1,1) ;Create ZEM segment for Patient (param 3 = 1)
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZEN(DFN,",1,9,",1,"",HL("FS")) ;Create ZEN segment and add to message array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZMH(DFN,DGMIEN,",4,") ;Create the ZMH segment and store in the output array
-	Q
+DGRUGA01 ;ALB/GRR - HL7 ADT A01 MESSAGE BUILDER ;06/08/99
+ ;;5.3;Registration;**190,303**;Aug 13, 1993
+ ;
+ ;This routine will build a ADT A01 (Admit) HL7 message for an inpatient.
+ ;
+EN(DFN,DGMIEN,DGARRAY) ;Entry point of routine
+ ;DFN - Patient Internal Entry Number
+ ;DGMIEN - Patient Movement Internal Entry Number
+ ;DGARRAY - Name of output array by reference where built message will be contained.
+ ;
+ ;The HL7 variables must be initialized before calling this routine!
+ ;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
+ ;
+ N DGPV1,DGHOLD,DGCNT,DGMDT,DGCDT,DGOADT,DGZEL,DGICD,DGICDCNT,DGIN,DGIN1,DGRB,DGW,DGINCNT S DGCNT=0
+ Q:DGARRAY=""  ;Required output variable name was not passed
+ K @DGARRAY ;Kill output array to insure erroneous data does not exist
+ Q:DGMIEN=""
+ S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
+ D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
+ S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
+ S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A01","05",DGMDT) ;Create Event segment and store in output array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
+ S DGHOLD=$$EN^VAFHLNK1(DFN,DGMIEN,",2,3,4,5,") ;Create the NK1 segment using the segment sequence numbers passed, and store in output array
+ I DGHOLD]"" S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGHOLD
+ S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
+ S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,",$G(DGMIEN),"","") ;Create the PV1 segment based on sequence numbers passed, and store in output array
+ S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;Check if integrated site and get original admit date
+ ;Check if doing data seed of RAI/MDS machine
+ I $G(DGSEED)=1 D
+ .N VAIP,DGPCPNM,DGPCPPTR,DGWPTR,DGRBPTR,DGWTRAN,DGRBTRAN
+ .D IN5^VADPT
+ .;Put current Primary Care Physician into PV1 segment
+ .S DGPCPPTR=+$G(VAIP(7))
+ .S DGPCPNM=$$HLNAME^HLFNC($P($G(VAIP(7)),"^",2))
+ .S:DGPCPNM="" DGPCPNM=HL("Q")
+ .S $P(DGPV1,HL("FS"),8)=DGPCPPTR_$E(HL("ECH"))_DGPCPNM
+ .;Get current ward & room/bed
+ .S DGW=$$GET1^DIQ(2,DFN,.1,"I")
+ .S DGRB=$$GET1^DIQ(2,DFN,.101,"I")
+ .;Convert ward & room/bed to pointers
+ .S DGWPTR=$$FIND1^DIC(42,,"XQ",DGW)
+ .S DGRBPTR=$$FIND1^DIC(405.4,,"XQ",DGRB)
+ .;Translate ward & room/bed
+ .S DGWTRAN=$$WARDTRAN^DGRUUTL1(DGWPTR,DGW)
+ .S DGRBTRAN=$$RBTRAN^DGRUUTL1(DGRBPTR,DGRB)
+ .;Put translated ward & room/bed into PV1 segment
+ .S $P(DGPV1,HL("FS"),4)=DGWTRAN_$E(HL("ECH"))_$P(DGRBTRAN,"-")_$E(HL("ECH"))_$P(DGRBTRAN,"-",2)
+ I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT) S $P(@DGARRAY@(1),HL("FS"),7)=$$HLDATE^HLFNC(DGOADT)
+ S DGPV1=$$DOCID^DGRUUTL(DGPV1)
+ ;TRANSLATE WARD AND ROOM-BED NAMES IF NEEDED (ALREADY DONE IF SEEDING)
+ S:'$G(DGSEED) DGPV1=$$LOCTRAN^DGRUUTL1(DGPV1)
+ S @DGARRAY@(DGCNT)=DGPV1
+ S DGCNT=DGCNT+1 ;Increment node counter to store next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLPV2(DFN,DGMIEN,",3,") ;Create PV2 segment
+ D IN^VAFHLDG1(DFN,DGMIEN,",2,3,5,","DGICD",DGMDT) ;Create the DG1 segment(s) and store in a temporary array
+ I $O(DGICD(0))>0 D  ;DG1 segment were built
+ .S DGICDCNT=0 F  S DGICDCNT=$O(DGICD(DGICDCNT)) Q:DGICDCNT=""  S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGICD(DGICDCNT,0) ;Loop through temporary array and store DG1 segment(s) in output array
+ S DGIN1=$$IN1^DGRUUTL1(DFN)
+ S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGIN1
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLIN2(DFN,DGMIEN,",2,3,6,8,") ;Create and store IN2 segment in output array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S DGZEL=$$EN^VAFHLZEL(DFN,",1,8,",1) ;Create ZEL segment (only primary eligibility - param 3 = 1)
+ I $P(DGZEL,HL("FS"),9)'=0&($P(DGZEL,HL("FS"),9)'=1) S $P(DGZEL,HL("FS"),9)=1 ;stuff patient as veteran
+ S @DGARRAY@(DGCNT)=DGZEL
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZEM(DFN,",1,5,",1,1) ;Create ZEM segment for Patient (param 3 = 1)
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZEN(DFN,",1,9,",1,"",HL("FS")) ;Create ZEN segment and add to message array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZMH(DFN,DGMIEN,",4,") ;Create the ZMH segment and store in the output array
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA08.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA08.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA08.m	(revision 623)
@@ -1,61 +1,60 @@
-DGRUGA08	;ALB/GRR - HL7 ADT A08 MESSAGE BUILDER ; 10/11/07 9:24am
-	;;5.3;Registration;**190,312,328,721,762**;Aug 13, 1993;Build 3
-	;
-	;This routine will build a ADT A08 (Patient Update) HL7 message for an inpatient.
-	;
-EN(DFN,DGMIEN,DGARRAY,DGDC,DGSSNC)	;Entry point of routine
-	;DFN - Patient Internal Entry Number
-	;DGMIEN - Patient Movement Internal Entry Number
-	;DGARRAY - Name of output array by reference where built message will be contained.
-	;DGDC - date type~prior date (date type is A, T, or D) (Required for date change only) [Optional]
-	;DGSSNC - Prior SSN (Required for SSN Change only) [Optional]
-	;
-	;The HL7 variables must be initialized before calling this routine!
-	;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
-	;
-	N DGPV1,DGHOLD,DGCNT,DGMDT,DGCDT,DGOADT,DGIN1,DGLMT,DGZEL,DGICD,DGICDCNT,DGIN,DGINCNT S DGCNT=0
-	Q:DGARRAY=""  ;Required output variable name was not passed
-	K @DGARRAY ;Kill output array to insure erroneous data does not exist
-	I DGMIEN="" N VAIP D NOW^%DTC S VAIP("D")=% D IN5^VADPT S DGMIEN=$G(VAIP(1)) K VAIP Q:DGMIEN=""  ;changed p-328
-	D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
-	S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
-	S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
-	S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A08","05",DGMDT) ;Create Event segment and store in output array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
-	S DGHOLD=$$EN^VAFHLNK1(DFN,DGMIEN,",2,3,4,5,") ;Create the NK1 segment using the segment sequence numbers passed, and store in output array
-	I DGHOLD]"" S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGHOLD
-	S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
-	S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,45,",DGMIEN,"","") ;Create the PV1 segment based on sequence numbers passed
-	S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;check if integrated site get original admit date/time
-	I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT)
-	S DGPV1=$$DOCID^DGRUUTL(DGPV1)
-	I $G(DGLMT)=1,$E($G(DGDC))="D" S $P(DGPV1,HL("FS"),4)=$P(DGPV1,HL("FS"),7) ;This is a change to a prior HL7, move prior location to current
-	N VAIP D IN5^VADPT S $P(DGPV1,HL("FS"),11)=$$GET1^DIQ(45.7,+VAIP(8),1,"I") K VAIP ; p-721
-	K ATTDOC S ATTDOC=$$ATTDOC^DGRUUTL(.ATTDOC) S $P(DGPV1,HL("FS"),18)=ATTDOC K ATTDOC ; P-762
-	S @DGARRAY@(DGCNT)=$$LOCTRAN^DGRUUTL1(DGPV1)
-	S DGCNT=DGCNT+1 ;Increment node counter to store next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLPV2(DFN,DGMIEN,",3,") ;Create PV2 segment
-	D IN^VAFHLDG1(DFN,DGMIEN,",2,3,5,","DGICD") ;Create the DG1 segment(s) and store in a temporary array
-	I $O(DGICD(0))>0 D  ;DG1 segment were built
-	.S DGICDCNT=0 F  S DGICDCNT=$O(DGICD(DGICDCNT)) Q:DGICDCNT=""  S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGICD(DGICDCNT,0) ;Loop through temporary array and store DG1 segment(s) in output array
-	S DGIN1=$$IN1^DGRUUTL1(DFN)
-	S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGIN1
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLIN2(DFN,DGMIEN,",2,3,6,8,") ;Create and store IN2 segment in output array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S DGZEL=$$EN^VAFHLZEL(DFN,",1,8,",1) ;Create ZEL segment (only primary eligibility - param 3 = 1)
-	I $P(DGZEL,HL("FS"),9)'=0&($P(DGZEL,HL("FS"),9)'=1) S $P(DGZEL,HL("FS"),9)=1 ;stuff patient as veteran
-	S @DGARRAY@(DGCNT)=DGZEL
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZEM(DFN,",1,5,",1,1) ;Create ZEM segment for Patient (param 3 = 1)
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZEN(DFN,",1,9,",1,"",HL("FS")) ;Create ZEN segment and add to message array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFHLZMH(DFN,DGMIEN,",4,") ;Create the ZMH segment and store in the output array
-	S DGDC=$G(DGDC),DGSSNC=$G(DGSSNC)
-	I DGDC]""!(DGSSNC]"") D  ;date or ssn change
-	.I DGDC]""&'("ADT"[$E(DGDC)) Q
-	.S DGCNT=DGCNT+1
-	.S @DGARRAY@(DGCNT)=$$EN^DGRUGZDC(DFN,DGDC,DGSSNC,DGMDT)
-	Q
+DGRUGA08 ;ALB/GRR - HL7 ADT A08 MESSAGE BUILDER ; 21 Sep 2006  8:24 AM
+ ;;5.3;Registration;**190,312,328,721**;Aug 13, 1993;Build 3
+ ;
+ ;This routine will build a ADT A08 (Patient Update) HL7 message for an inpatient.
+ ;
+EN(DFN,DGMIEN,DGARRAY,DGDC,DGSSNC) ;Entry point of routine
+ ;DFN - Patient Internal Entry Number
+ ;DGMIEN - Patient Movement Internal Entry Number
+ ;DGARRAY - Name of output array by reference where built message will be contained.
+ ;DGDC - date type~prior date (date type is A, T, or D) (Required for date change only) [Optional]
+ ;DGSSNC - Prior SSN (Required for SSN Change only) [Optional]
+ ;
+ ;The HL7 variables must be initialized before calling this routine!
+ ;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
+ ;
+ N DGPV1,DGHOLD,DGCNT,DGMDT,DGCDT,DGOADT,DGIN1,DGLMT,DGZEL,DGICD,DGICDCNT,DGIN,DGINCNT S DGCNT=0
+ Q:DGARRAY=""  ;Required output variable name was not passed
+ K @DGARRAY ;Kill output array to insure erronuous data does not exist
+ I DGMIEN="" N VAIP D NOW^%DTC S VAIP("D")=% D IN5^VADPT S DGMIEN=$G(VAIP(1)) K VAIP Q:DGMIEN=""  ;changed p-328
+ D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
+ S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
+ S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
+ S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A08","05",DGMDT) ;Create Event segment and store in output array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
+ S DGHOLD=$$EN^VAFHLNK1(DFN,DGMIEN,",2,3,4,5,") ;Create the NK1 segment using the segment sequence numbers passed, and store in output array
+ I DGHOLD]"" S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGHOLD
+ S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
+ S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,45,",DGMIEN,"","") ;Create the PV1 segment based on sequence numbers passed
+ S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;check if integrated site get original admit date/time
+ I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT)
+ S DGPV1=$$DOCID^DGRUUTL(DGPV1)
+ I $G(DGLMT)=1,$E($G(DGDC))="D" S $P(DGPV1,HL("FS"),4)=$P(DGPV1,HL("FS"),7) ;This is a change to a prior HL7, move prior location to current
+ N VAIP D IN5^VADPT S $P(DGPV1,HL("FS"),11)=$$GET1^DIQ(45.7,+VAIP(8),1,"I") K VAIP ; p-721
+ S @DGARRAY@(DGCNT)=$$LOCTRAN^DGRUUTL1(DGPV1)
+ S DGCNT=DGCNT+1 ;Increment node counter to store next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLPV2(DFN,DGMIEN,",3,") ;Create PV2 segment
+ D IN^VAFHLDG1(DFN,DGMIEN,",2,3,5,","DGICD") ;Create the DG1 segment(s) and store in a temporary array
+ I $O(DGICD(0))>0 D  ;DG1 segment were built
+ .S DGICDCNT=0 F  S DGICDCNT=$O(DGICD(DGICDCNT)) Q:DGICDCNT=""  S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGICD(DGICDCNT,0) ;Loop through temporary array and store DG1 segment(s) in output array
+ S DGIN1=$$IN1^DGRUUTL1(DFN)
+ S DGCNT=DGCNT+1,@DGARRAY@(DGCNT)=DGIN1
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLIN2(DFN,DGMIEN,",2,3,6,8,") ;Create and store IN2 segment in output array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S DGZEL=$$EN^VAFHLZEL(DFN,",1,8,",1) ;Create ZEL segment (only primary eligibility - param 3 = 1)
+ I $P(DGZEL,HL("FS"),9)'=0&($P(DGZEL,HL("FS"),9)'=1) S $P(DGZEL,HL("FS"),9)=1 ;stuff patient as veteran
+ S @DGARRAY@(DGCNT)=DGZEL
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZEM(DFN,",1,5,",1,1) ;Create ZEM segment for Patient (param 3 = 1)
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZEN(DFN,",1,9,",1,"",HL("FS")) ;Create ZEN segment and add to message array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFHLZMH(DFN,DGMIEN,",4,") ;Create the ZMH segment and store in the output array
+ S DGDC=$G(DGDC),DGSSNC=$G(DGSSNC)
+ I DGDC]""!(DGSSNC]"") D  ;date or ssn change
+ .I DGDC]""&'("ADT"[$E(DGDC)) Q
+ .S DGCNT=DGCNT+1
+ .S @DGARRAY@(DGCNT)=$$EN^DGRUGZDC(DFN,DGDC,DGSSNC,DGMDT)
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA22.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA22.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGA22.m	(revision 623)
@@ -1,34 +1,33 @@
-DGRUGA22	;ALB/GRR - HL7 ADT A22 MESSAGE BUILDER ; 11/7/07 3:45pm
-	;;5.3;Registration;**190,762**;Aug 13, 1993;Build 3
-	;
-	;This routine will build a ADT A22 (From Leave of Absence) HL7 message for an inpatient.
-	;
-EN(DFN,DGMIEN,DGARRAY)	;Entry point of routine
-	;DFN - Patient Internal Entry Number
-	;DGMIEN - Patient Movement Internal Entry Number
-	;DGARRAY - Name of output array by reference where built message will be contained.
-	;
-	;The HL7 variables must be initialized before calling this routine!
-	;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
-	;
-	N DGPV1,DGCNT,DGMDT,DGCDT,DGOADT,DGICD,DGICDCNT,DGIN,DGINCNT S DGCNT=0
-	Q:DGARRAY=""  ;Required output variable name was not passed
-	K @DGARRAY ;Kill output array to insure erroneous data does not exist
-	Q:DGMIEN=""
-	S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
-	D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
-	S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
-	S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A22","05",DGMDT) ;Create Event segment and store in output array
-	S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
-	S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
-	S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I") ;Retrieve Movement Date/Time
-	S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
-	S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,",$G(DGMIEN),"","") ;Create the PV1 segment based on sequence numbers passed
-	S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;check if integrated site get original admit date/time
-	I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT)
-	S DGPV1=$$DOCID^DGRUUTL(DGPV1)
-	N VAIP,DGW,DGRM D IN5^VADPT S DGW=$P(VAIP(5),"^",2),DGRM=$P(VAIP(6),"^",2),$P(DGPV1,HL("FS"),4)=DGW_$E(HLECH)_DGRM K VAIP ; P-762
-	S @DGARRAY@(DGCNT)=$$LOCTRAN^DGRUUTL1(DGPV1) ;Translate Ward and Room-Bed name, store into array
-	S DGMTYP=$$GET1^DIQ(405,DGMIEN,.18,"I") ;Get Movement Type
-	I DGMTYP=14!(DGMTYP=41) S $P(@DGARRAY@(DGCNT),HL("FS"),41)="H" ;If From ASIH flag bed status field as 'H'
-	Q
+DGRUGA22 ;ALB/GRR - HL7 ADT A22 MESSAGE BUILDER ;8/5/99  15:36
+ ;;5.3;Registration;**190**;Aug 13, 1993
+ ;
+ ;This routine will build a ADT A22 (From Leave of Absence) HL7 message for an inpatient.
+ ;
+EN(DFN,DGMIEN,DGARRAY) ;Entry point of routine
+ ;DFN - Patient Internal Entry Number
+ ;DGMIEN - Patient Movement Internal Entry Number
+ ;DGARRAY - Name of output array by reference where built message will be contained.
+ ;
+ ;The HL7 variables must be initialized before calling this routine!
+ ;HL("FS"),HL("ECH"),HLFS,HLECH, and HLQ are used by segment builders called by this routine
+ ;
+ N DGPV1,DGCNT,DGMDT,DGCDT,DGOADT,DGICD,DGICDCNT,DGIN,DGINCNT S DGCNT=0
+ Q:DGARRAY=""  ;Required output variable name was not passed
+ K @DGARRAY ;Kill output array to insure erronuous data does not exist
+ Q:DGMIEN=""
+ S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I")
+ D NOW^%DTC S DGCDT=$$HLDATE^HLFNC(%) ;Get current date/time and convert to HL7 format
+ S DGCNT=DGCNT+1 ;Increment node counter by one for first segment
+ S @DGARRAY@(DGCNT)=$$EVN^VAFHLEVN("A22","05",DGMDT) ;Create Event segment and store in output array
+ S DGCNT=DGCNT+1 ;Increment node counter by one for next segment
+ S @DGARRAY@(DGCNT)=$$EN^VAFCPID(DFN,",2,5,7,8,10,11,13,16,17,19,23,29",1) ;Create PID segment using segment sequence numbers passed and store in output array
+ S DGMDT=$$GET1^DIQ(405,DGMIEN,".01","I") ;Retrieve Movement Date/Time
+ S DGCNT=DGCNT+1 ;Increment node counter by one to store next segment
+ S DGPV1=$$IN^VAFHLPV1(DFN,DGMDT,",2,3,6,7,10,17,44,",$G(DGMIEN),"","") ;Create the PV1 segment based on sequence numbers passed
+ S DGOADT=$$CKADMIT^DGRUUTL1(DFN) ;check if integrated site get original admit date/time
+ I DGOADT]"" S $P(DGPV1,HL("FS"),45)=$$HLDATE^HLFNC(DGOADT)
+ S DGPV1=$$DOCID^DGRUUTL(DGPV1)
+ S @DGARRAY@(DGCNT)=$$LOCTRAN^DGRUUTL1(DGPV1) ;Translate Ward and Room-Bed name, store into array
+ S DGMTYP=$$GET1^DIQ(405,DGMIEN,.18,"I") ;Get Movement Type
+ I DGMTYP=14!(DGMTYP=41) S $P(@DGARRAY@(DGCNT),HL("FS"),41)="H" ;If From ASIH flag bed status field as 'H'
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGBJ.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGBJ.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUGBJ.m	(revision 623)
@@ -1,112 +1,111 @@
-DGRUGBJ	; ALB/SCK - RAI/MDS COTS ADT Background job ; 11/7/07 3:49pm
-	;;5.3;Registration;**190,312,357,762**;Aug 13, 1993;Build 3
-	;
-EN	; Main Entry point for patient demographic update to COTS system
-	;
-	L +^XTMP("ADT/HL7 MDS COTS UPDATE"):3 E  Q
-	;
-	; Check for HL7 send parameter
-	Q:'$P($$SEND^VAFHUTL(),"^",2)
-	;
-	; Look for patient demographic changes monitored by the COTS system
-	N PVTPTR,DGNODE,DFN,DGDATE,DGARRAY,DGUSR,DGRSLT
-	;
-	S DGARRAY="^TMP(""DGRAI"",""EVNTINFO"","_$J_")"
-	K @DGARRAY
-	;
-	; Begin looking for entries needing transmission with a type of "COTS UPDATE", Code 6.
-	S PVTPTR=0
-	F  S PVTPTR=+$O(^VAT(391.71,"AXMIT",6,PVTPTR)) Q:('PVTPTR)  D
-	. ; If no entry for xref (out of sync) delete the xref and quit
-	. I ('$D(^VAT(391.71,PVTPTR))) K ^VAT(391.71,"AXMIT",6,PVTPTR) Q
-	. ; Get event date and pointer to patient for entry
-	. S DGNODE=$G(^VAT(391.71,PVTPTR,0))
-	. S DFN=+$P(DGNODE,"^",3)
-	. S EVNTDT=+DGNODE
-	. ; Check for patient, if not valid, then mark as transmitted and quit
-	. I ('$D(^DPT(DFN,0))) D XMITFLAG^VAFCDD01(PVTPTR,"",1) Q
-	. N VAIN D INP^VADPT ; p-762
-	. I '$$CHKWARD^DGRUUTL(+VAIN(4)) D XMITFLAG^VAFCDD01(PVTPTR,"",1) K VAIN Q  ; P-762
-	. K @DGARRAY
-	. S @DGARRAY@("PIVOT")=PVTPTR
-	. S @DGARRAY@("REASON",1)=""
-	. I (+$G(^DPT(DFN,.35))) S @DGARRAY@("REASON",1)=99
-	. ;
-	. S @DGARRAY@("USER")=$$GET1^DIQ(200,+$P(DGNODE,"^",9),.01)
-	. ;
-	. S @DGARRAY@("EVENT-NUM")=$P(DGNODE,"^",2)
-	. S @DGARRAY@("VAR-PTR")=$P(DGNODE,"^",5)
-	. ;
-	. S DGRSLT=$$BLDA08(DFN,EVNTDT,DGARRAY)
-	. I (DGRSLT<0) D ERRBUL(DGARRAY,DGRSLT) ;deleted Q p-357
-	. ;
-	. ; Mark entry in pivot file as transmitted
-	. D XMITFLAG^VAFCDD01(PVTPTR,"",1)
-	;
-	L -^XTMP("ADT/HL7 MDS COTS UPDATE")
-	Q
-	;
-BLDA08(DFN,EVNTDT,EVNTINFO,DGDC,DGOSSN)	;
-	;
-	N RESULT,DGTMP,GLOREF
-	;
-	S DFN=+$G(DFN)
-	I ('$D(^DPT(DFN,0))) S RESULT="-1^Could not find entry in PATIENT file" G BLDQ
-	;
-	S DGDC=$G(DGDC)
-	S DGOSSN=$G(DGOSSN)
-	S EVNTDT=$G(EVNTDT)
-	S:('EVNTDT) EVNTDT=$$NOW^XLFDT
-	;
-	S GLOREF="^TMP(""HLS"","_$J_")"
-	K @GLOREF
-	;
-	S @EVNTINFO@("DFN")=DFN
-	S @EVNTINFO@("EVENT")="A08"
-	S @EVNTINFO@("DATE")=EVNTDT
-	;
-	N HLEID,HL,HLFS,HLECH,HLQ,NDX
-	;
-	K HL
-	D INIT^HLFNC2("DGRU-PATIENT-A08-SERVER",.HL)
-	;
-	I ($O(HL(""))']"") S RESULT="-1^Server Protocol not found" G BLDQ
-	;
-	; Build segment array
-	D EN^DGRUGA08(DFN,"","DGTMP",DGDC,DGOSSN)
-	I '$O(DGTMP(0)) S RESULT="-1^Unable to build segment list to transmit" G BLDQ
-	;Check segment list for errors
-	S NDX=0
-	F  S NDX=$O(DGTMP(NDX)) Q:'NDX  D  G:(+$G(RESULT)<0) BLDQ
-	. I +DGTMP(NDX)<0 S RESULT="-1^An error occurred in one of the segments"
-	;
-	M @GLOREF=DGTMP
-	S RESULT=$$SENDMSG(GLOREF)
-	I +$P(RESULT,"^",2)>0 S RESULT="-1^"_$P(RESULT,"^",2,3)
-BLDQ	Q $G(RESULT)
-	;
-SENDMSG(GLOREF)	; Transmit the HL7 message
-	N HLA,HLRST
-	M HLA("HLS")=@GLOREF
-	I $D(HLA("HLS")) D
-	. D GENERATE^HLMA("DGRU-PATIENT-A08-SERVER","LM",1,.HLRST,"")
-	K HLA,HERR
-	Q (HLRST)
-	;
-ERRBUL(EVNTINFO,RESULT)	; Generate bulletin if an error occurred while building the HL7 message.
-	;
-	N XMY,XMDUZ,XMDT,XMZ,XMB,XMCHAN,XMSUB
-	;
-	S XMCHAN=1
-	S XMSUB="RAI/MDS HL7 BUILD ERROR"
-	S (XMDUZ,XMDUZ)="RAI/MDS APPLICATION"
-	;
-	S XMB="DGRU RAI ERROR"
-	S XMB(1)=$$GET1^DIQ(2,@EVNTINFO@("DFN"),.01)
-	S XMB(2)=@EVNTINFO@("EVENT")
-	S XMB(3)=">>> "_$P(RESULT,"^",2)
-	S XMB(4)=@EVNTINFO@("USER")
-	S XMB(5)=$$FMTE^XLFDT(@EVNTINFO@("DATE"))
-	S XMDT=DT
-	D ^XMB
-	Q
+DGRUGBJ ; ALB/SCK - RAI/MDS COTS ADT Background job ; 8-10-99
+ ;;5.3;Registration;**190,312,357**;Aug 13, 1993
+ ;
+EN ; Main Entry point for patient demographic update to COTS system
+ ;
+ L +^XTMP("ADT/HL7 MDS COTS UPDATE"):3 E  Q
+ ;
+ ; Check for HL7 send parameter
+ Q:'$P($$SEND^VAFHUTL(),"^",2)
+ ;
+ ; Look for patient demographic changes monitored by the COTS system
+ N PVTPTR,DGNODE,DFN,DGDATE,DGARRAY,DGUSR,DGRSLT
+ ;
+ S DGARRAY="^TMP(""DGRAI"",""EVNTINFO"","_$J_")"
+ K @DGARRAY
+ ;
+ ; Begin looking for entries needing transmission with a type of "COTS UPDATE", Code 6.
+ S PVTPTR=0
+ F  S PVTPTR=+$O(^VAT(391.71,"AXMIT",6,PVTPTR)) Q:('PVTPTR)  D
+ . ; If no entry for xref (out of sync) delete the xref and quit
+ . I ('$D(^VAT(391.71,PVTPTR))) K ^VAT(391.71,"AXMIT",6,PVTPTR) Q
+ . ; Get event date and pointer to patient for entry
+ . S DGNODE=$G(^VAT(391.71,PVTPTR,0))
+ . S DFN=+$P(DGNODE,"^",3)
+ . S EVNTDT=+DGNODE
+ . ; Check for patient, if not valid, then mark as transmitted and quit
+ . I ('$D(^DPT(DFN,0))) D XMITFLAG^VAFCDD01(PVTPTR,"",1) Q
+ . ;
+ . K @DGARRAY
+ . S @DGARRAY@("PIVOT")=PVTPTR
+ . S @DGARRAY@("REASON",1)=""
+ . I (+$G(^DPT(DFN,.35))) S @DGARRAY@("REASON",1)=99
+ . ;
+ . S @DGARRAY@("USER")=$$GET1^DIQ(200,+$P(DGNODE,"^",9),.01)
+ . ;
+ . S @DGARRAY@("EVENT-NUM")=$P(DGNODE,"^",2)
+ . S @DGARRAY@("VAR-PTR")=$P(DGNODE,"^",5)
+ . ;
+ . S DGRSLT=$$BLDA08(DFN,EVNTDT,DGARRAY)
+ . I (DGRSLT<0) D ERRBUL(DGARRAY,DGRSLT) ;deleted Q p-357
+ . ;
+ . ; Mark entry in pivot file as transmitted
+ . D XMITFLAG^VAFCDD01(PVTPTR,"",1)
+ ;
+ L -^XTMP("ADT/HL7 MDS COTS UPDATE")
+ Q
+ ;
+BLDA08(DFN,EVNTDT,EVNTINFO,DGDC,DGOSSN) ;
+ ;
+ N RESULT,DGTMP,GLOREF
+ ;
+ S DFN=+$G(DFN)
+ I ('$D(^DPT(DFN,0))) S RESULT="-1^Could not find entry in PATIENT file" G BLDQ
+ ;
+ S DGDC=$G(DGDC)
+ S DGOSSN=$G(DGOSSN)
+ S EVNTDT=$G(EVNTDT)
+ S:('EVNTDT) EVNTDT=$$NOW^XLFDT
+ ;
+ S GLOREF="^TMP(""HLS"","_$J_")"
+ K @GLOREF
+ ;
+ S @EVNTINFO@("DFN")=DFN
+ S @EVNTINFO@("EVENT")="A08"
+ S @EVNTINFO@("DATE")=EVNTDT
+ ;
+ N HLEID,HL,HLFS,HLECH,HLQ,NDX
+ ;
+ K HL
+ D INIT^HLFNC2("DGRU-PATIENT-A08-SERVER",.HL)
+ ;
+ I ($O(HL(""))']"") S RESULT="-1^Server Protocol not found" G BLDQ
+ ;
+ ; Build segment array
+ D EN^DGRUGA08(DFN,"","DGTMP",DGDC,DGOSSN)
+ I '$O(DGTMP(0)) S RESULT="-1^Unable to build segment list to transmit" G BLDQ
+ ;Check segment list for errors
+ S NDX=0
+ F  S NDX=$O(DGTMP(NDX)) Q:'NDX  D  G:(+$G(RESULT)<0) BLDQ
+ . I +DGTMP(NDX)<0 S RESULT="-1^An error occurred in one of the segments"
+ ;
+ M @GLOREF=DGTMP
+ S RESULT=$$SENDMSG(GLOREF)
+ I +$P(RESULT,"^",2)>0 S RESULT="-1^"_$P(RESULT,"^",2,3)
+BLDQ Q $G(RESULT)
+ ;
+SENDMSG(GLOREF) ; Transmit the HL7 message
+ N HLA,HLRST
+ M HLA("HLS")=@GLOREF
+ I $D(HLA("HLS")) D
+ . D GENERATE^HLMA("DGRU-PATIENT-A08-SERVER","LM",1,.HLRST,"")
+ K HLA,HERR
+ Q (HLRST)
+ ;
+ERRBUL(EVNTINFO,RESULT) ; Generate bulliten if an error occurred while building the HL7 message.
+ ;
+ N XMY,XMDUZ,XMDT,XMZ,XMB,XMCHAN,XMSUB
+ ;
+ S XMCHAN=1
+ S XMSUB="RAI/MDS HL7 BUILD ERROR"
+ S (XMDUZ,XMDUZ)="RAI/MDS APPLICATION"
+ ;
+ S XMB="DGRU RAI ERROR"
+ S XMB(1)=$$GET1^DIQ(2,@EVNTINFO@("DFN"),.01)
+ S XMB(2)=@EVNTINFO@("EVENT")
+ S XMB(3)=">>> "_$P(RESULT,"^",2)
+ S XMB(4)=@EVNTINFO@("USER")
+ S XMB(5)=$$FMTE^XLFDT(@EVNTINFO@("DATE"))
+ S XMDT=DT
+ D ^XMB
+ Q
